/* Convenience class for implementing an undoable/redoable drag and drop.

Notes
	- Works by doing three total actons, the middle one being the annotation delete.
	- Then when undo is called on the third action, it triggers the 2 prior undos as well.

*/

var ImgDrop = function(pull, annGuid) {
	this.pull = pull;
	this.annGuid = annGuid;
	this.oldSrc = '';
	this.oldText = '';

	NB.undomanager.performUndoableAction(this.redo.bind(this), this.undo.bind(this));
};

ImgDrop.prototype = {

	redo: function() {
		this.oldSrc = $('#contentImg').attr('src');
		this.oldText = $('#contentInput').val();
		try {
			var ann = NB.getObject(this.annGuid);
			new ImgUrlConverter(ann.getPreview(), this.onImgUrlConvert.bind(this));
		} catch(e) {}
	},

	undo: function() {
		this.pull.view.setContent(this.oldSrc, this.oldText);
		this.pull.writePersist();
		this.pull.updateThumb();
	},

	onImgUrlConvert: function(converter, newUrl) {
		if(newUrl) {
			this.pull.view.setImg(newUrl);
			try {
				var ann = NB.getObject(this.annGuid);
				NB.page.deleteObject(ann);
				NB.undomanager.performUndoableAction(this.redo2.bind(this), this.undo2.bind(this));
			} catch(e) {}
			this.pull.writePersist();
			this.pull.updateThumb();
		}
	},

	redo2: function() {
	},

	undo2: function() {
		NB.undomanager.undo();
		NB.undomanager.undo();
	},

};