/* Object that converts a generic resource url to a data URI. Does so via a canvas element. */
var ImgUrlConverter = function(url, onEnd) {
	this.img = new Image();
	this.img.crossOrigin = 'Anonymous';
	this.img.onload = this.onload.bind(this);
	this.img.src = url;
	this.onEnd = onEnd; //function(ImgConvert, newUrl)
};

ImgUrlConverter.prototype = {

	onload: function() {
		var jq = $('<canvas/>');
		var canvas = jq[0];
        var ctx = canvas.getContext('2d');
        canvas.height = this.img.height;
        canvas.width = this.img.width;
        ctx.drawImage(this.img, 0, 0);
        this.onEnd(this, canvas.toDataURL('image/png'));
        this.img = null;
        this.onEnd = null;
	},

};
